//+------------------------------------------------------------------+
//|                                                    Rmo Cross.mq4 |
//|                         Copyright  2008-2010, TradingSytemForex |
//|                                http://www.tradingsystemforex.com |
//+------------------------------------------------------------------+

#property copyright "Copyright  2008-2010, TradingSytemForex"
#property link "http://www.tradingsystemforex.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue
#property indicator_color2 OrangeRed

double CrossUp[];
double CrossDown[];
double state[];
datetime prevtime;
double Range,AvgRange;
double LimeRmonow,LimeRmoprevious;
double GoldRmonow,GoldRmoprevious;

extern int MainFilterSpeed=8;
extern int MainFilterSlow=16;
extern int SmallFilterSpeed=3;
extern int SmallFilterSlow=12;

double MainFiltersMultipleFactor=1.0;
double SmallFiltersMultipleFactor=1.0;

int SlowFilterOffset=0;

double emaBuffer[999];
double emaRes[999];

//+------------------------------------------------------------------+
//| Initialization                                                   |
//+------------------------------------------------------------------+

int init()
{
//---- indicators
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_ARROW,EMPTY,2);
   SetIndexArrow(0,233);
   SetIndexBuffer(0,CrossUp);
   SetIndexStyle(1,DRAW_ARROW,EMPTY,2);
   SetIndexArrow(1,234);
   SetIndexBuffer(1,CrossDown);
   SetIndexBuffer(2,state);
//----
   return(0);
}
  
//+------------------------------------------------------------------+
//| Deinitialization                                                 |
//+------------------------------------------------------------------+

int deinit()
{
//---- 

//----
   return(0);
}

double getAbsEMACO(int period, int shift){
  if(iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,shift+period+1)==0)return(0);
  else{
    int i=0;
    for(i=0;i<period;i++){emaBuffer[period-1-i]=MathAbs(iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,shift+i)-iMA(NULL,0,1,0,MODE_SMA,PRICE_OPEN,shift+i));}
    double pr=2.0/(period+1);
    emaRes[0]=emaBuffer[0];
    for(i=1;i<period;i++){emaRes[i]=emaBuffer[i]*pr+emaRes[i-1]*(1-pr);}
    return(emaRes[period-1]);
  }
}

double getEMACO(int period,int shift){

  if(iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,shift+period+1)==0)return(0);
  else{
    int i=0;
    for(i=0;i<period;i++){emaBuffer[period-1-i]=(iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,shift+i)-iMA(NULL,0,1,0,MODE_SMA,PRICE_OPEN,shift+i));}
    double pr=2.0/(period+1);
    emaRes[0]=emaBuffer[0];
    for(i=1;i<period;i++){emaRes[i]=emaBuffer[i]*pr+emaRes[i-1]*(1-pr);}
    return(emaRes[period-1]);
  }

}

//+------------------------------------------------------------------+
//| Iteration                                                        |
//+------------------------------------------------------------------+

int start()
{
   int limit,i,counter;
   int counted_bars=IndicatorCounted();

   if(counted_bars<0)return(-1);
   if(counted_bars>0)counted_bars--;
   
   limit=Bars-counted_bars;
   
   for(i=limit;i>=0;i--)
   {
      counter=i;
      Range=0;
      AvgRange=0;
      for(counter=i;counter<=i+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;

      int signal=0;
      int currOffSet=i;

      if(getAbsEMACO(MainFilterSpeed,currOffSet)>getAbsEMACO(MainFilterSlow,currOffSet+SlowFilterOffset)){

      double _smallFilterSpeed=getEMACO(SmallFilterSpeed,currOffSet);      
      double _SmallFilterSlow=getAbsEMACO(SmallFilterSlow,currOffSet);

      if(_smallFilterSpeed>_SmallFilterSlow*SmallFiltersMultipleFactor)signal=1;
      else if(_smallFilterSpeed<-_SmallFilterSlow*SmallFiltersMultipleFactor)signal=-1;
    }
      
      state[i] = state[i+1];
      if(signal==1)
      {
         CrossUp[i]=Low[i]-Range*0.5; state[i] = 1;
       }
       
      if(signal==-1)
      {
         CrossDown[i]=High[i]+Range*0.5; state[i] = -1;
      }
   }
   if((CrossUp[0]>2000) && (CrossDown[0]>2000)){prevtime=0;}
   if(state[0]!=state[1] && state[0]==1 && prevtime!=Time[0])
   {
      prevtime=Time[0];
      Alert(Symbol()," ELVP Cross Up @  Hour ",Hour(),"  Minute ",Minute());
   } 
   if(state[0]!=state[1] && state[0]==-1 && prevtime!=Time[0])
   {
      prevtime=Time[0];
      Alert(Symbol()," ELVP Cross Down @  Hour ",Hour(),"  Minute ",Minute());
   }
   return(0);
 }

